/*
   Copyright  1995-2001, The AROS Development Team. All rights reserved.
   $Id: gadgets.c,v 1.1.1.1 2005/03/15 15:54:23 laire Exp $
 
   Desc: GadTools gadget creation functions
   Lang: English
*/

/****************************************************************************************/

#include <stdio.h>
#include <proto/exec.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <exec/memory.h>
#include <proto/intuition.h>
#include <graphics/gfxmacros.h>
#include <intuition/intuition.h>
#include <intuition/classusr.h>
#include <intuition/gadgetclass.h>
#include <intuition/imageclass.h>
#include <intuition/screens.h>
#include <intuition/icclass.h>
#include <proto/utility.h>
#include <utility/tagitem.h>
#include <libraries/gadtools.h>

#if 0
#define SDEBUG 0
#define DEBUG 0
#endif

#include "gadtools_intern.h"

/****************************************************************************************/

#define EG(x) ((struct ExtGadget *)(x))

/****************************************************************************************/

struct Gadget *makebutton(struct GadToolsBase_intern *GadToolsBase,
			                          struct TagItem stdgadtags[],
			                          struct VisualInfo *vi,
			                          struct TagItem *taglist)
{
	struct Gadget *obj;
	Class *cl;
#if 0
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled	, FALSE
		    },
		    {GA_Immediate	, FALSE		},
		    {GA_RelVerify	, TRUE		},
		    {TAG_MORE	, (IPTR) NULL	}
	    };

	cl = makebuttonclass(GadToolsBase);
	if (!cl)
		return NULL;

	tags[0].ti_Data = GetTagData(GA_Disabled, FALSE, taglist);
	tags[1].ti_Data = GetTagData(GA_Immediate, FALSE, taglist);
	tags[3].ti_Data = (IPTR) stdgadtags;

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);
#else
	struct TagItem tags[2] =
	    {
		    {
			    GA_RelVerify,	TRUE
		    },
		    {TAG_MORE,	0	}
	    };

	cl = makebuttonclass(GadToolsBase);
	if (!cl)
		return NULL;

	tags[1].ti_Data = (IPTR)taglist;

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)tags;

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);
#endif

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	return obj;
}

/****************************************************************************************/

struct Gadget *makecheckbox(struct GadToolsBase_intern *GadToolsBase,
			                            struct TagItem stdgadtags[],
			                            struct VisualInfo *vi,
			                            struct TagItem *taglist)
{
	struct IClass *cl;
	struct Gadget *obj;
#if 0
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled	, FALSE
		    },
		    {GTCB_Checked	, FALSE		},
		    {TAG_MORE	, (IPTR)NULL	}
	    };

	EnterFunc(bug("makecheckbox()\n"));

	tags[0].ti_Data = GetTagData(GA_Disabled, FALSE, taglist);
	tags[1].ti_Data = GetTagData(GTCB_Checked, FALSE, taglist);
	tags[2].ti_Data = (IPTR) stdgadtags;

	if (!GetTagData(GTCB_Scaled, FALSE, taglist))
	{
		stdgadtags[TAG_Width].ti_Data = CHECKBOX_WIDTH;
		stdgadtags[TAG_Height].ti_Data = CHECKBOX_HEIGHT;
	}

	cl = makecheckboxclass(GadToolsBase);
	if (!cl)
		return (NULL);

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);
#else
EnterFunc(bug("makecheckbox()\n"));

	if (!GetTagData(GTCB_Scaled, FALSE, taglist))
	{
		stdgadtags[TAG_Width].ti_Data = CHECKBOX_WIDTH;
		stdgadtags[TAG_Height].ti_Data = CHECKBOX_HEIGHT;
	}

	cl = makecheckboxclass(GadToolsBase);
	if (!cl)
		return (NULL);

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)taglist;
	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);
#endif
	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	ReturnPtr("makecheckbox()", struct Gadget *, obj);
}

/****************************************************************************************/

struct Gadget *makecycle(struct GadToolsBase_intern *GadToolsBase,
			                         struct TagItem stdgadtags[],
			                         struct VisualInfo *vi,
			                         struct TagItem *taglist)
{
	struct IClass *cl;
	struct Gadget *obj;
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled	, FALSE
		    }
		    , /* 0 */
		    {GTCY_Labels	, FALSE		}, /* 1 */
		    {GTCY_Active	, 0		}, /* 2 */
		    {GA_RelVerify	, TRUE		}, /* 3 */
		    {TAG_MORE	, (IPTR)NULL	}  /* 4 */
	    };

	EnterFunc(bug("makecycle()\n"));

	tags[0].ti_Data = GetTagData(GA_Disabled, FALSE, taglist);
	tags[1].ti_Data = GetTagData(GTCY_Labels, FALSE, taglist);
	tags[2].ti_Data = GetTagData(GTCY_Active, 0, taglist);

	tags[4].ti_Data = (IPTR) stdgadtags;

	cl = makecycleclass(GadToolsBase);
	if (!cl)
		return (NULL);

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	ReturnPtr("makecycle()", struct Gadget *, obj);
}

/****************************************************************************************/

struct Gadget *makemx(struct GadToolsBase_intern *GadToolsBase,
			                      struct TagItem stdgadtags[],
			                      struct VisualInfo *vi,
			                      struct TagItem *taglist)
{
	struct IClass *cl;
	struct Gadget *obj;
	int labels = 0;
	STRPTR *labellist;
	struct TagItem *tag, tags[] =
	    {
		    {
			    GA_Disabled		, FALSE
		    }
		    , /* 0 */
		    {GTMX_Labels		, (IPTR) NULL		}, /* 1 */
		    {GTMX_Active		, 0			}, /* 2 */
		    {GTMX_Spacing		, 1			}, /* 3 */
		    {GTMX_TickHeight	, MX_HEIGHT		}, /* 4 */
		    {GTMX_TickLabelPlace	, GV_LabelPlace_Right	}, /* 5 */
		    {TAG_IGNORE		, 0			}, /* 6 */
		    {TAG_MORE		, (IPTR) NULL		}  /* 7 */
	    };

	tags[0].ti_Data = GetTagData(GA_Disabled, FALSE, taglist);
	labellist = (STRPTR *) GetTagData(GTMX_Labels, (IPTR) NULL, taglist);
	if (!labellist)
		return NULL;
	tags[1].ti_Data = (IPTR) labellist;
	tags[2].ti_Data = GetTagData(GTMX_Active, 0, taglist);
	tags[3].ti_Data = GetTagData(GTMX_Spacing, 1, taglist);
	if (GetTagData(GTMX_Scaled, FALSE, taglist))
		tags[4].ti_Data = stdgadtags[TAG_Height].ti_Data;
	else
		stdgadtags[TAG_Width].ti_Data = MX_WIDTH;
	switch (stdgadtags[TAG_LabelPlace].ti_Data & 0x1f)
	{
	case GV_LabelPlace_Left:
		tags[5].ti_Data = GV_LabelPlace_Left;
		break;
	case GV_LabelPlace_Above:
		tags[5].ti_Data = GV_LabelPlace_Above;
		break;
	case GV_LabelPlace_Below:
		tags[5].ti_Data = GV_LabelPlace_Below;
		break;
	}

	/* Need to pass this to mxclass - Piru */
	tag = FindTagItem(GT_Underscore, taglist);
	if (tag)
	{
		tags[6] = *tag;
	}

	tags[7].ti_Data = (IPTR) stdgadtags;

	tag = FindTagItem(GTMX_TitlePlace, taglist);
	if (tag)
	{
		switch (tag->ti_Data)
		{
		case PLACETEXT_LEFT:
			stdgadtags[TAG_LabelPlace].ti_Data = GV_LabelPlace_Left;
			break;
		case PLACETEXT_RIGHT:
			stdgadtags[TAG_LabelPlace].ti_Data = GV_LabelPlace_Right;
			break;
		case PLACETEXT_ABOVE:
			stdgadtags[TAG_LabelPlace].ti_Data = GV_LabelPlace_Above;
			break;
		case PLACETEXT_BELOW:
			stdgadtags[TAG_LabelPlace].ti_Data = GV_LabelPlace_Below;
			break;
		default:
			freeitext(GadToolsBase,
			          (struct IntuiText *)stdgadtags[TAG_IText].ti_Data);
			stdgadtags[TAG_IText].ti_Data = (IPTR)NULL;
			break;
		}
	}
	else
	{
		freeitext(GadToolsBase,
		          (struct IntuiText *)stdgadtags[TAG_IText].ti_Data);
		stdgadtags[TAG_IText].ti_Data = (IPTR)NULL;
	}

	while (labellist[labels])
		labels++;

	cl = makemxclass(GadToolsBase);
	if (!cl)
		return (NULL);

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	return obj;
}

/****************************************************************************************/

struct Gadget *makepalette(struct GadToolsBase_intern *GadToolsBase,
			                           struct TagItem stdgadtags[],
			                           struct VisualInfo *vi,
			                           struct TagItem *taglist)
{
	struct IClass *cl;
	struct Gadget *obj = NULL;

	struct TagItem *tag, tags[] =
	    {
		    {
			    GA_RelVerify,		TRUE
		    }
		    , /* 0 */
		    {GA_Disabled,		FALSE		}, /* 1 */
		    {GTPA_Depth,		1		}, /* 2 */
		    {GTPA_Color,		0		}, /* 3 */
		    {GTPA_ColorOffset,	0		}, /* 4 */
		    {GTPA_IndicatorWidth,	0		}, /* 5 */
		    {GTPA_IndicatorHeight,	0		}, /* 6 */
		    {GTPA_NumColors,	2		}, /* 7 */
		    {GTPA_ColorTable,	0		}, /* 8 */
		    {TAG_MORE,		(IPTR)NULL	}
	    };

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		/* Note: GTPA_NumColors overrides GTPA_Depth tag! */

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[1].ti_Data = tidata;
			break;
		case GTPA_Depth:
			tags[2].ti_Data	= tidata;
			tags[7].ti_Data = 1L << tidata;
			break;
		case GTPA_Color:
			tags[3].ti_Data	= tidata;
			break;
		case GTPA_ColorOffset:
			tags[4].ti_Data	= tidata;
			break;
		case GTPA_IndicatorWidth:
			tags[5].ti_Data	= tidata;
			break;
		case GTPA_IndicatorHeight:
			tags[6].ti_Data	= tidata;
			break;
		case GTPA_NumColors:
			tags[7].ti_Data	= tidata;
			break;
		case GTPA_ColorTable:
			tags[8].ti_Data	= tidata;
			break;

		} /* switch() */

	} /* while (iterate taglist) */

	tags[9].ti_Data = (IPTR)stdgadtags;

	cl = makepaletteclass(GadToolsBase);
	if (!cl)
		return (NULL);

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	return obj;
}

/****************************************************************************************/

struct Gadget *maketext(struct GadToolsBase_intern *GadToolsBase,
			                        struct TagItem stdgadtags[],
			                        struct VisualInfo *vi,
			                        struct TagItem *taglist)
{
	struct Gadget *obj = NULL;
	Class *cl;
	BOOL cliptag_found = FALSE;

	struct TagItem *tag, tags[] =
	    {
		    {
			    GTTX_Text		, 0
		    },
		    {GTTX_CopyText		, FALSE			},
		    {GTTX_Clipped		, FALSE			},
		    {GTTX_Border		, FALSE			},
		    {GTTX_FrontPen		, vi->vi_dri->dri_Pens[TEXTPEN]		},
		    {GTTX_BackPen		, vi->vi_dri->dri_Pens[BACKGROUNDPEN]		},
		    {GTTX_Justification	, GTJ_LEFT		},
		    {GTA_Text_Format	, (IPTR)"%s"		},
		    {GTA_GadgetKind		, TEXT_KIND		},
		    {TAG_MORE		, (IPTR) NULL		}
	    };

	DEBUG_CREATETEXT(bug("maketext:\n"));

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GTTX_Text:
			tags[0].ti_Data = tidata;
			break;
		case GTTX_CopyText:
			tags[1].ti_Data	= tidata;
			break;
		case GTTX_Clipped:
			tags[2].ti_Data	= tidata;
			cliptag_found = TRUE;
			break;
		case GTTX_Border:
			tags[3].ti_Data	= tidata;
			break;
		case GTTX_FrontPen:
			tags[4].ti_Data	= tidata;
			break;
		case GTTX_BackPen:
			tags[5].ti_Data	= tidata;
			break;
		case GTTX_Justification:
			tags[6].ti_Data	= tidata;
			break;
		}

	} /* while (iterate taglist) */

	/* if GTTX_Clipped was not specified then the default value is
	   the GTTX_Border value */

	if (!cliptag_found) tags[2].ti_Data = tags[3].ti_Data;

	tags[9].ti_Data = (IPTR)stdgadtags;

	cl = maketextclass(GadToolsBase);
	if (!cl)
		return (NULL);
	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	DEBUG_CREATETEXT(bug("maketext: obj 0x%lx\n",obj));
	return (obj);
}

/****************************************************************************************/

struct Gadget *makenumber(struct GadToolsBase_intern *GadToolsBase,
			                          struct TagItem stdgadtags[],
			                          struct VisualInfo *vi,
			                          struct TagItem *taglist)
{
	struct Gadget *obj = NULL;
	Class *cl;
	BOOL cliptag_found = FALSE;

	struct TagItem *tag, tags[] =
	    {
		    {
			    GTNM_Number		, 0
		    },
		    {GTNM_Format		, (IPTR)"%ld"	},
		    {GTNM_Clipped		, FALSE		},
		    {GTNM_Border		, FALSE		},
		    {GTNM_FrontPen		, vi->vi_dri->dri_Pens[TEXTPEN]	},
		    {GTNM_BackPen		, vi->vi_dri->dri_Pens[BACKGROUNDPEN]	},
		    {GTNM_Justification	, GTJ_CENTER	},
		    {GTNM_MaxNumberLen	, 100		},
		    {GTA_GadgetKind		, NUMBER_KIND	},
		    {TAG_MORE		, (IPTR) NULL	}
	    };


	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GTNM_Number:
			tags[0].ti_Data = tidata;
			break;
		case GTNM_Format:
			tags[1].ti_Data	= tidata;
			break;
		case GTNM_Clipped:
			tags[2].ti_Data	= tidata;
			cliptag_found = TRUE;
			break;
		case GTNM_Border:
			tags[3].ti_Data	= tidata;
			break;
		case GTNM_FrontPen:
			tags[4].ti_Data	= tidata;
			break;
		case GTNM_BackPen:
			tags[5].ti_Data	= tidata;
			break;
		case GTNM_Justification:
			tags[6].ti_Data	= tidata;
			break;
		case GTNM_MaxNumberLen:
			tags[7].ti_Data	= tidata;
			break;
		}

	} /* while (iterate taglist) */

	/* if GTNM_Clipped was not specified then the default value is
	   the GTNM_Border value */

	if (!cliptag_found) tags[2].ti_Data = tags[3].ti_Data;

	tags[9].ti_Data = (IPTR)stdgadtags;

	cl = maketextclass(GadToolsBase);
	if (!cl)
		return (NULL);
	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

	return  (obj);
}


/****************************************************************************************/

struct Gadget *makeslider(struct GadToolsBase_intern *GadToolsBase,
			                          struct TagItem stdgadtags[],
			                          struct VisualInfo *vi,
			                          struct TagItem *taglist)
{
	struct Gadget *obj;
	Class *cl;
#if 0
	struct TagItem *tag;
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled		, FALSE
		    },
		    {GA_RelVerify		, FALSE		},
		    {GA_Immediate		, FALSE		},
		    {GTSL_Min		, 0		},
		    {GTSL_Max		, 15		},
		    {GTSL_Level		, 0		},
		    {GTSL_MaxLevelLen	, 0		},
		    {GTSL_LevelFormat	, 0		},
		    {GTSL_LevelPlace	, PLACETEXT_LEFT},
		    {GTSL_DispFunc		, (IPTR)NULL	},
		    {GTSL_MaxPixelLen	, 0		},
		    {TAG_IGNORE		, 0		}, //GTSL_Justification
		    {PGA_Freedom		, LORIENT_HORIZ	},
		    {TAG_MORE		, (IPTR) NULL	}
	    };

	cl = makeslidergclass(GadToolsBase);
	if (!cl)
		return NULL;

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((const struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[0].ti_Data = tidata;
			break;
		case GA_RelVerify:
			tags[1].ti_Data = tidata;
			break;
		case GA_Immediate:
			tags[2].ti_Data = tidata;
			break;
		case GTSL_Min:
			tags[3].ti_Data = tidata;
			break;
		case GTSL_Max:
			tags[4].ti_Data = tidata;
			break;
		case GTSL_Level:
			tags[5].ti_Data = tidata;
			break;
		case GTSL_MaxLevelLen:
			tags[6].ti_Data = tidata;
			break;
		case GTSL_LevelFormat:
			tags[7].ti_Data = tidata;
			break;
		case GTSL_LevelPlace:
			tags[8].ti_Data = tidata;
			break;
		case GTSL_DispFunc:
			tags[9].ti_Data = tidata;
			break;
		case GTSL_MaxPixelLen:
			tags[10].ti_Data = tidata;
			break;
		case GTSL_Justification:
			tags[11] = *tag;
			break;
		case PGA_Freedom:
			tags[12].ti_Data = tidata;
			break;
		}

	} /* while (iterate taglist) */

	tags[13].ti_Data = (IPTR) stdgadtags;

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);
	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}
#else

cl = makeslidergclass(GadToolsBase);
	if (!cl)
		return NULL;

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)taglist;

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);

#endif
	return obj;
}

/****************************************************************************************/

#ifdef SDEBUG
#   undef SDEBUG
#endif
#ifdef DEBUG
#   undef DEBUG
#endif
//#define SDEBUG 1
//#define DEBUG 1
#include <aros/debug.h>

/****************************************************************************************/

struct Gadget *makescroller(struct GadToolsBase_intern *GadToolsBase,
			                            struct TagItem stdgadtags[],
			                            struct VisualInfo *vi,
			                            struct TagItem *taglist)
{
	struct Gadget *obj;
	Class *cl;
#if 0
	struct TagItem *tag;
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled	, FALSE
		    },
		    {GA_RelVerify	, FALSE		},
		    {GA_Immediate	, FALSE		},
		    {GTSC_Top	, 0		},
		    {GTSC_Total	, 0		},
		    {GTSC_Visible	, 2		},
		    {GTSC_Arrows	, 0		},
		    {PGA_Freedom	, LORIENT_HORIZ	},
		    //{GTA_Scroller_ArrowKind, SCROLLER_KIND},
		    //{GTA_Scroller_ScrollerKind, SCROLLER_KIND},
		    {TAG_MORE	, (IPTR) NULL	}
	    };

	cl = makescrollergclass(GadToolsBase);
	if (!cl)
		return NULL;

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((const struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[0].ti_Data = tidata;
			break;
		case GA_RelVerify:
			tags[1].ti_Data = tidata;
			break;
		case GA_Immediate:
			tags[2].ti_Data = tidata;
			break;
		case GTSC_Top:
			tags[3].ti_Data = tidata;
			break;
		case GTSC_Total:
			tags[4].ti_Data = tidata;
			break;
		case GTSC_Visible:
			tags[5].ti_Data = tidata;
			break;
		case GTSC_Arrows:
			tags[6].ti_Data = tidata;
			break;
		case PGA_Freedom:
			tags[7].ti_Data = tidata;
			break;
			//case GTA_Scroller_ArrowKind: tags[8].ti_Data = tidata; break;
			//case GTA_Scroller_ScrollerKind: tags[9].ti_Data = tidata; break;
		}


	} /* while (iterate taglist) */

	tags[8].ti_Data = (IPTR) stdgadtags;

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

#else

	cl = makescrollergclass(GadToolsBase);
	if (!cl)
		return NULL;

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)taglist;

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);

#endif

	return obj;
}

/****************************************************************************************/

struct Gadget *makestring(struct GadToolsBase_intern *GadToolsBase,
			                          struct TagItem stdgadtags[],
			                          struct VisualInfo *vi,
			                          struct TagItem *taglist)
{
	struct Gadget *obj = NULL;
	Class *cl;

#if 0
	struct IBox bbox;


	struct TagItem *tag, tags[] =
	    {
		    {
			    GA_Disabled		, FALSE
		    }
		    , /* 0 */
		    {GA_Immediate		, FALSE			}, /* 1 */
		    {GA_RelVerify		, TRUE			}, /* 2 */
		    {GA_TabCycle		, TRUE			}, /* 3 */
		    {GTST_String		, (IPTR)NULL		}, /* 4 */
		    {GTST_MaxChars		, 64UL			}, /* 5 */
		    {GTST_EditHook		, (IPTR)NULL		}, /* 6 */
		    {STRINGA_ExitHelp	, FALSE			}, /* 7 */
		    {STRINGA_Justification	, GACT_STRINGLEFT	}, /* 8 */
		    {STRINGA_ReplaceMode	, FALSE			}, /* 9 */
		    {GTA_GadgetKind		, STRING_KIND		}, /* 10 */
		    {GA_Bounds		, (IPTR)&bbox		}, /* 11 */
		    {TAG_MORE		, (IPTR)NULL		}  /* 12 */
	    };


	DEBUG_CREATESTRING(bug("makestring:\n"));

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((const struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[0].ti_Data = tidata;
			break;
		case GA_Immediate:
			tags[1].ti_Data	= tidata;
			break;
		case GA_RelVerify:
			tags[2].ti_Data = tidata;
			break;
		case GA_TabCycle:
			tags[3].ti_Data	= tidata;
			break;
		case GTST_String:
			tags[4].ti_Data	= tidata;
			break;
		case GTST_MaxChars:
			tags[5].ti_Data	= tidata;
			break;
		case GTST_EditHook:
			tags[6].ti_Data	= tidata;
			break;
		case STRINGA_ExitHelp:
			tags[7].ti_Data	= tidata;
			break;
		case STRINGA_Justification:
			tags[8].ti_Data	= tidata;
			break;
		case STRINGA_ReplaceMode:
			tags[9].ti_Data	= tidata;
			break;
		}

	} /* while (iterate taglist) */

	/* if there is a bounding box the label position
	   will be calculated based on this box and not
	   the gadget coords */

	bbox.Left   = GetTagData(GA_Left, 0, stdgadtags);
	bbox.Top    = GetTagData(GA_Top,  0, stdgadtags);
	bbox.Width  = GetTagData(GA_Width, 0, stdgadtags);
	bbox.Height = GetTagData(GA_Height, 0, stdgadtags);

	/* There are always GA_Left, GA_Top, GA_Width and GA_Height tags
	   thanks to creategadgeta.c! */

	FindTagItem(GA_Left,stdgadtags)->ti_Data   += BORDERSTRINGSPACINGX;
	FindTagItem(GA_Top,stdgadtags)->ti_Data    += BORDERSTRINGSPACINGY;
	FindTagItem(GA_Width,stdgadtags)->ti_Data  -= BORDERSTRINGSPACINGX * 2;
	FindTagItem(GA_Height,stdgadtags)->ti_Data -= BORDERSTRINGSPACINGY * 2;

	tags[12].ti_Data = (IPTR)stdgadtags;

	cl = makestringclass(GadToolsBase);
	if (!cl)
		return (NULL);
	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);

	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

#else

cl = makestringclass(GadToolsBase);
	if (!cl)
		return (NULL);

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)taglist;

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);

#endif

	return  (obj);
}

/****************************************************************************************/

struct Gadget *makeinteger(struct GadToolsBase_intern *GadToolsBase,
			                           struct TagItem stdgadtags[],
			                           struct VisualInfo *vi,
			                           struct TagItem *taglist)
{
	struct Gadget *obj = NULL;
	Class *cl;

#if 0
	struct IBox bbox;

	struct TagItem *tag, tags[] =
	    {
		    {
			    GA_Disabled		, FALSE
		    }
		    , /* 0 */
		    {GA_Immediate		, FALSE			}, /* 1 */
		    {GA_RelVerify		, TRUE			}, /* 2 */
		    {GA_TabCycle		, TRUE			}, /* 3 */
		    {GTIN_Number		, 0L			}, /* 4 */
		    {GTIN_MaxChars		, 10L			}, /* 5 */
		    {GTIN_EditHook		, (IPTR)NULL		}, /* 6 */
		    {STRINGA_ExitHelp	, FALSE			}, /* 7 */
		    {STRINGA_Justification	, GACT_STRINGLEFT	}, /* 8 */
		    {STRINGA_ReplaceMode	, FALSE			}, /* 9 */
		    {GTA_GadgetKind		, INTEGER_KIND		}, /* 10 */
		    {GA_Bounds		, (IPTR)&bbox		}, /* 11 */
		    {TAG_MORE		, (IPTR)NULL		}  /* 12 */
	    };


	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((const struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[0].ti_Data = tidata;
			break;
		case GA_Immediate:
			tags[1].ti_Data	= tidata;
			break;
		case GA_RelVerify:
			tags[2].ti_Data = tidata;
			break;
		case GA_TabCycle:
			tags[3].ti_Data	= tidata;
			break;
		case GTIN_Number:
			tags[4].ti_Data	= tidata;
			break;
		case GTIN_MaxChars:
			tags[5].ti_Data	= tidata;
			break;
		case GTIN_EditHook:
			tags[6].ti_Data	= tidata;
			break;
		case STRINGA_ExitHelp:
			tags[7].ti_Data	= tidata;
			break;
		case STRINGA_Justification:
			tags[8].ti_Data	= tidata;
			break;
		case STRINGA_ReplaceMode:
			tags[9].ti_Data	= tidata;
			break;
		}

	} /* while (iterate taglist) */

	/* if there is a bounding box the label position
	   will be calculated based on this box and not
	   the gadget coords */

	bbox.Left   = GetTagData(GA_Left, 0, stdgadtags);
	bbox.Top    = GetTagData(GA_Top,  0, stdgadtags);
	bbox.Width  = GetTagData(GA_Width, 0, stdgadtags);
	bbox.Height = GetTagData(GA_Height, 0, stdgadtags);

	/* There are always GA_Left, GA_Top, GA_Width and GA_Height tags
	   thanks to creategadgeta.c! */

	FindTagItem(GA_Left,stdgadtags)->ti_Data   += BORDERSTRINGSPACINGX;
	FindTagItem(GA_Top,stdgadtags)->ti_Data    += BORDERSTRINGSPACINGY;
	FindTagItem(GA_Width,stdgadtags)->ti_Data  -= BORDERSTRINGSPACINGX * 2;
	FindTagItem(GA_Height,stdgadtags)->ti_Data -= BORDERSTRINGSPACINGY * 2;

	tags[12].ti_Data = (IPTR)stdgadtags;

	cl = makestringclass(GadToolsBase);
	if (!cl)
		return (NULL);
	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);
	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}

#else

struct TagItem tags[] =
	{
		{
			GTIN_MaxChars,	0
		},
		{TAG_MORE,	 }
	};

	tags[0].ti_Data = GetTagData(GTIN_MaxChars, 10, taglist);
	tags[1].ti_Data = (IPTR)taglist;

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)tags;

	cl = makestringclass(GadToolsBase);
	if (!cl)
		return (NULL);

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);

#endif
	return  (obj);
}


/****************************************************************************************/

struct Gadget *makelistview(struct GadToolsBase_intern *GadToolsBase,
			                            struct TagItem stdgadtags[],
			                            struct VisualInfo *vi,
			                            struct TagItem *taglist)
{
	struct Gadget *obj;
	Class *cl;
#if 0
	struct TagItem *tag;
	struct TagItem tags[] =
	    {
		    {
			    GA_Disabled	, FALSE
		    },
		    {LAYOUTA_Spacing, 0		},
		    {GTLV_Top	, 0		},
		    {GTLV_Labels	, (IPTR) NULL	},
		    {GTLV_ReadOnly	, FALSE		},
		    {GTLV_ScrollWidth, 16		},
		    {GTLV_ShowSelected, (IPTR) NULL },
		    {GTLV_Selected	, ~0		},
		    {GTLV_ItemHeight, 0		},
		    {GTLV_CallBack	, (IPTR) NULL	},
		    {GTLV_MaxPen	, 0		},
		    {TAG_IGNORE	, 0		}, /* GTLV_MakeVisible */
		    {TAG_MORE	, (IPTR) NULL	}
	    };

	cl = makelistviewgclass(GadToolsBase);
	if (!cl)
		return NULL;

	/* Could use GetTagData(), but this is faster */
	while ((tag = NextTagItem((const struct TagItem **)&taglist)))
	{
		IPTR tidata = tag->ti_Data;

		switch (tag->ti_Tag)
		{
		case GA_Disabled:
			tags[0].ti_Data = tidata;
			break;
		case LAYOUTA_Spacing:
			tags[1].ti_Data = tidata;
			break;
		case GTLV_Top:
			tags[2].ti_Data = tidata;
			break;
		case GTLV_Labels:
			tags[3].ti_Data = tidata;
			break;
		case GTLV_ReadOnly:
			tags[4].ti_Data = tidata;
			break;
		case GTLV_ScrollWidth:
			tags[5].ti_Data = tidata;
			break;
		case GTLV_ShowSelected:
			tags[6].ti_Data = tidata;
			break;
		case GTLV_Selected:
			tags[7].ti_Data = tidata;
			break;
		case GTLV_ItemHeight:
			tags[8].ti_Data = tidata;
			break;
		case GTLV_CallBack:
			tags[9].ti_Data = tidata;
			break;
		case GTLV_MaxPen:
			tags[10].ti_Data = tidata;
			break;
		case GTLV_MakeVisible:
			tags[11] = *tag;
			break;
		}

	} /* while (iterate taglist) */

	tags[12].ti_Data = (IPTR) stdgadtags;

	obj = (struct Gadget *) NewObjectA(cl, NULL, tags);
	if (obj)
	{
		obj->GadgetType |= GTYP_GADTOOLS;
	}
#else

	cl = makelistviewgclass(GadToolsBase);
	if (!cl)
		return (NULL);

	stdgadtags[TAG_More].ti_Tag = TAG_MORE;
	stdgadtags[TAG_More].ti_Data = (IPTR)taglist;

	obj = (struct Gadget *) NewObjectA(cl, NULL, stdgadtags);

#endif
	return obj;
}

/****************************************************************************************/

struct Gadget *makegeneric(struct GadToolsBase_intern *GadToolsBase,
			                           struct TagItem stdgadtags[],
			                           struct VisualInfo *vi,
			                           struct TagItem *taglist)
{
	struct GT_GenericGadget *gad;
	struct Gadget	    *prevgad;

	gad = gtAllocMem(sizeof(struct GT_GenericGadget), MEMF_PUBLIC | MEMF_CLEAR);
	if (gad)
	{
		gad->gad.LeftEdge	= stdgadtags[TAG_Left].ti_Data;
		gad->gad.TopEdge	= stdgadtags[TAG_Top].ti_Data;
		gad->gad.Width		= stdgadtags[TAG_Width].ti_Data;
		gad->gad.Height		= stdgadtags[TAG_Height].ti_Data;
		gad->gad.Flags		= GFLG_EXTENDED;
		gad->gad.Activation	= 0;
		gad->gad.GadgetType	= GTYP_GADTOOLS;
		gad->gad.GadgetRender	= NULL;
		gad->gad.SelectRender	= NULL;
		gad->gad.GadgetText	= (struct IntuiText *)stdgadtags[TAG_IText].ti_Data;
		gad->gad.MutualExclude	= 0;
		gad->gad.SpecialInfo	= NULL;
		gad->gad.GadgetID	= stdgadtags[TAG_ID].ti_Data;
		gad->gad.UserData	= (APTR)stdgadtags[TAG_UserData].ti_Data;
		gad->gad.MoreFlags	= GMORE_BOUNDS | GMORE_GADGETHELP;
		gad->gad.BoundsLeftEdge = stdgadtags[TAG_Left].ti_Data;
		gad->gad.BoundsTopEdge	= stdgadtags[TAG_Top].ti_Data;
		gad->gad.BoundsWidth	= stdgadtags[TAG_Width].ti_Data;
		gad->gad.BoundsHeight	= stdgadtags[TAG_Height].ti_Data;
		gad->magic		= GENERIC_MAGIC;
		gad->magic2		= GENERIC_MAGIC2;
		gad->itext		= (struct IntuiText *)stdgadtags[TAG_IText].ti_Data;

		prevgad = (struct Gadget *)stdgadtags[TAG_Previous].ti_Data;
		prevgad->NextGadget = (struct Gadget *)gad;
	}

	ReturnPtr ("makegeneric", struct Gadget *, (struct Gadget *)gad);
}

/****************************************************************************************/
