/*
    Copyright  1995-2001, The AROS Development Team. All rights reserved.
    $Id: gt_replyimsg.c,v 1.1.1.1 2005/03/15 15:54:23 laire Exp $
 
    Desc:
    Lang: english
*/
#include <proto/exec.h>
#include <exec/ports.h>

#if 0
#define SDEBUG 1
#define DEBUG 1
#endif

#include "gadtools_intern.h"

/*********************************************************************
 
    NAME */
#include <proto/gadtools.h>
#include <intuition/intuition.h>

AROS_LH1(void, GT_ReplyIMsg,

         /*  SYNOPSIS */
         AROS_LHA(struct IntuiMessage *, imsg, A1),

         /*  LOCATION */
         struct Library *, GadToolsBase, 13, GadTools)

/*  FUNCTION
        Replies a message gotten via GT_GetIMsg().
 
    INPUTS
        imsg - The message to reply.
 
    RESULT
 
    NOTES
 
    EXAMPLE
 
    BUGS
 
    SEE ALSO
        GT_GetIMsg(), exec.library/ReplyMsg()
 
    INTERNALS
 
    HISTORY
 
***************************************************************************/
{
	AROS_LIBFUNC_INIT
	AROS_LIBBASE_EXT_DECL(struct GadToolsBase *,GadToolsBase)

	struct IntuiMessage *origmsg;

	D(bug("ReplyIMsg: imsg 0x%lx\n",imsg));

	if (imsg != NULL)
	{
		if ((origmsg = GT_PostFilterIMsg(imsg)) != NULL)
		{
			D(bug("ReplyIMsg: GT_PostFilterIMsg(0x%lx) returned 0x%lx\n",imsg,origmsg));

			ReplyMsg(&origmsg->ExecMessage);
		}
	}

	D(bug("ReplyIMsg: done\n"));

	AROS_LIBFUNC_EXIT

} /* GT_ReplyIMsg */
